package pl.mpak.sky.gui.swing.syntax.structure;

import pl.mpak.sky.gui.swing.syntax.SQLSyntaxDocument;
import pl.mpak.sky.gui.swing.syntax.SyntaxDocument;
import pl.mpak.sky.gui.swing.syntax.SyntaxEditor.TokenRef;
import pl.mpak.sky.gui.swing.syntax.structure.core.ParserException;

public abstract class SqlStructureParser extends StructureParser {

  public SqlStructureParser() {
  }

  protected boolean updateStyle(int orygStyleId) {
    return 
      orygStyleId == SyntaxDocument.NONE ||
      orygStyleId == SQLSyntaxDocument.IDENTIFIER;
  }
  
  protected TokenRef skipBlank() throws ParserException {
    if (getToken().styleId == SyntaxDocument.NONE || getToken().styleId == SQLSyntaxDocument.COMMENT || getToken().styleId == SQLSyntaxDocument.DOCUMENTATION) {
      while (nextToken() != null) {
        if (getToken().styleId != SyntaxDocument.NONE && getToken().styleId != SQLSyntaxDocument.COMMENT && getToken().styleId != SQLSyntaxDocument.DOCUMENTATION) {
          return getToken();
        }
      }
    }
    return currentToken;
  }

}
